
//******************************************************************//
//																	//
//				(C) 2017 R-MIK Sawomir Skrzyski for AVT			//
//				slawomir.skrzynski@ep.com.pl						//
//																	//
//	Programu nie mona rozpowszechnia bez pisemnej zgody autora!	//
//																	//
//******************************************************************//


#define	EMU_DEF		0x28 		// Startujemy w trybie skaner todo: dla testw emulator
//#define	EMU_DEF		0x01 		// Startujemy w trybie skaner todo: dla testw emulator

#define	DEMO_NOWAIT

//----- Ponisze w normalnej pracy powinny by wykomentowane -----//
#define	TRAP		nop()		// "nop();" aby mozna zaoyc papk, ";" gdy kod finalny
//#define	SALEAE					// Sygnay na portach PBx pytki CNT
//#define	TEST_PCBCNT				// Test na pycie Cnt&nvRam z M128 i SCK SPI

//#define	INT5_NAKED			// do tesu


//todo: zweryfikowa    #error "Zbyt mala czestotliwosc dla emulacji overdrive"


//******************************************************************//
// Warto "DELAYSAMPLE_1W" wynika z opnie i trzeba j "zmierzy" oscyloskopem.
// Prbka powinna byc pobrana 15us po opadajcym zboczu sygnau
// Opnienie to czas od zbocza opadajcego sygnau 1-Wire
//  do czasu pobrania prbki przez "WIRE1_RD" w "irq_RolByte()".
// Warto ta zmieni si nienacznie po usuniciu "znacznikw" dla oscyloskopu
								//-------------------------------------------------
								// wejcie	wejcie	strob	ZERO	"pipek"
								// w INT	w ROR..	odczytu			po 		na
#if F_CPU > 16000000			//-------------------------------------------------
 #define	DELAYSAMPLE_1W	4
 #define	DELAYZERO_1W	4
 #elif F_CPU ==  16000000		// 2,5		4,25	 -		 -		 -		 -
 #define	DELAYSAMPLE_1W	4	// 	-		 -		15,5	 -		6,5		0,5
 #define	DELAYZERO_1W	9	//	-		 -		 -		44,5	 -		 -
#elif F_CPU == 8000000			// 4,25		4,75	 -		 -		 -		 -
 #define	DELAYSAMPLE_1W	0	// 	-		 -		12		 -		7,5		1
 #define	DELAYZERO_1W	0	//	-		 -		 -		31		 -		 -
// #define	DELAYSAMPLE_1W	6	// 	-		 -		9		 -		7,5		1
// #define	DELAYZERO_1W	1	//	-		 -		 -		30		 -		 -
// #define	DELAYSAMPLE_1W	5	// 	-		 -		10		 -		7,5		1
// #define	DELAYZERO_1W	5	//	-		 -		 -		28		 -		 -
// #define	DELAYSAMPLE_1W	4	// 	-		 -		10		 -		7,5		1
// #define	DELAYZERO_1W	20	//	-		 -		 -		20		 -		 -
#else
 #error "Nieobslugiwane F_CPU"
#endif
								//
#define SAMPLE_BIT_ovd		 1	// Chwila pobrania prbki, ze wzgldu na IRQ NAKED wejcie w IRQ 0,6us
								// Prbka powinna by pobrana 2us po opadajcym zboczu sygnau
								//
//
#define	ALARM_OFF			// Wycza generowanie alarmw

//#define	ALARM_ALWYES_ON		// Zawsze generuje alarm/irq od slave

//#define	FAST1W				// Szybszy kod, mniejszy zgodno z emulowanym ukadem (np obsuga overdrive, alarmw dla DS1990A)

#define	OVERDRIVE_OFF		// Wycza tryb overdrive, mniejszy kod, mniejsze wymagania

//#define	OW_NO_INLINE		// Wycza inline, mniejszy kod ale wolniejszy
								// Uycie dao nieoczekiwane ofekty, kod zwikszy si!
//#define	OVD_WR_HARD			// Sprztowe generowanie zera w overdrive (wymaga przerzutnika D i jednej linii OUT)

//#define	OVD_RD_HARD			// j.w. odczyt bitu (wymaga D + multiwibrator + port IN)

//#define	OVD_WR_HARD			// Sprztowe generowanie zera w overdrive (wymaga przerzutnika D i jednej linii OUT)

//#define	OVD_RD_HARD			// j.w. odczyt bitu (wymaga D + multiwibrator + port IN)


#define WIRE1_PIN		PINB
#define WIRE1_DDR		DDRB
#define WIRE1_QD		PB2								// Port wyjciowy
#define WIRE1_IN		PB2								// Port wejciowy (oba mog by takie same)
#define WIRE1_PORT		PORTB							// Konieczne jeli _QD i _IN rne


#define BAUD 			250000
#define BAUD1 			250000
#include <rmik/include.h>
#include <rmik/onewire.h>
#include <rmik/onewire_DS18b20.h>
#include <rmik/onewire_DS2431.h>
#include <rmik/onewire_DS2502.h>


#if WIRE1_IN == WIRE1_QD
  #define WIRE1_RESET	WIRE1_DDR  |= (1<<WIRE1_QD)		// cignicie magistrali 1-wire do 0 poprzez ustawienie kierunku portu jako wyjciowy
  #define WIRE1_SET		WIRE1_DDR  &= ~(1<<WIRE1_QD)	// Zwolnienie magistrali 1-wire i tym samym podcignicie rezystorem do plusa zasilania
  #define WIRE1_RD		(WIRE1_PIN & (1<<WIRE1_IN))
#else
  #define WIRE1_RESET	WIRE1_PORT &= ~(1<<WIRE1_QD)	// Port=L
  #define WIRE1_SET		WIRE1_PORT |= (1<<WIRE1_QD)		// Port=H
  #define WIRE1_RD		(WIRE1_PIN & (1<<WIRE1_IN))
#endif

#if F_CPU == 16000000
  #define TIMER_PRESCALER_OW 		64					//Wartoc preskalera licznika Timer1
#elif F_CPU == 8000000
  #define TIMER_PRESCALER_OW 		32					//Wartoc preskalera licznika Timer1
#endif
#define	TCNT_OW					TCNT1
#define OCFA_OW					OCF1A
#define OCFB_OW					OCF1B
#define	TCCRB_OW				TCCR1
#define TIMSK_OW				TIMSK
#define TIFR_OW					TIFR
#define	TOIE_OW					TOIE1
#define OCIEA_OW				OCIE1A
#define OCIEB_OW				OCIE1B
#define	OCRA_OW					OCR1A
#define	OCRB_OW					OCR1B


#if F_CPU == 16000000
  #define START_TIMER_OW		TCNT_OW = 0; TCCRB_OW |= 7	//Konfiguracja Timer3: tryb normalny, preskaler = 1
#elif F_CPU == 8000000
  #define START_TIMER_OW		TCNT_OW = 0; TCCRB_OW |= 6	//Konfiguracja Timer3: tryb normalny, preskaler = 1
#endif
//#define STOP_TIMER_OW			TCCRB_OW = 0				//Zatrzymanie licznika Timer3
//Przeliczanie mikrosekund na tyknicia zegara Timera przy zadanej wartoci preskalera
#define microSecondsOW(us) 		((us)*(F_CPU/1000000)/TIMER_PRESCALER_OW)


//----- Definicja czasw pobierania prbek i samplowania w trybie emulacji i skanowania -----//
#define	 TIM_1W_RST			480-20
#define	 TIM_1W_RSTtpdh		 30					// tPDH
#define	 TIM_PRESENCE		160					// tPHL
#if F_CPU <= 16000000
 #define	 TIM_1W_RSTirq		3900
 #define	 TIM_1W_RSTfail		4000
 												// Max:	2900us przy 22MHz
												//		3500us przy 18MHz
												//		4090us przy 16MHz
												//		4400us przy 14,7MHz
#else
 #define	 TIM_1W_RSTirq		1000
 #define	 TIM_1W_RSTfail		2900
#endif

#define	 SAMPLE_BIT	 		 15-DELAYSAMPLE_1W
#define	 TIM_BIT_ZERO		 45-DELAYZERO_1W	// 45us (60-15)


#ifndef OVERDRIVE_OFF
 #if F_CPU < 11000000
// #if F_CPU < 12000000 && !defined( OVD_WR_HARD )
//OVD_RD_HARD gdy pobranie probki
  #error "Zbyt mala czestotliwosc dla emulacji overdrive"
 #endif
#endif

#if F_CPU < 4000000
 #error "Zbyt mala czestotliwosc dla emulacji 1-Wire"
#endif


#define	delayREAD_BIT_1W()		_delay_us( SAMPLE_BIT )


enum{ OW_IDLE,				// Stan bezczynnoci ukadu Slave - oczekiwanie na sygna Reset
	  OW_ACK,				// By nieoczekiwany reset, wygeneruj ACK
	  OW_WAIT_FOR_COMMAND,	// Oczekiwanie na rozkaz sterujcy
	  OW_READ_ROM,			// Oczekiwanie na READ_ROM (odczyt numeru ID)
	  OW_SEARCH_ROM,		// Oczekiwanie na SEARCH_ROM
	  OW_MATCHROM,			// Oczekiwanie na MATCH_ROM
	  OW_WAIT_SUBCOMMAND,	// Czeka na dane po SKIP, MATCH ROM lub RESUME
	  OW_HOST2SLAVE,		// Czeka na dane z mastera
	  OW_SLAVE2HOST			// odsya dane do mastera
	};


#ifndef EMU_DEF
  #define	EMU_DEF	0
#endif


#define	EMU_SCAN	0
#define	EMU_1990	0x01
#define	EMU_2400	0x01
#define	EMU_2401	0x01
#define	EMU_2411	0x01
#define	EMU_18B20	0x28
#define	EMU_2431	0x2d

#define	EMU_2502	0x09
#define	EMU_1820	0x10
#define	EMU_1920	0x10
#define	EMU_2430	0x14
#define	EMU_1971	0x14
#define	EMU_2432	0x33
#define	EMU_1961	0x33
#define	EMU_2433	0x23
#define	EMU_1973	0x23


#define	EMU_NUM		7
byte menuEmu[EMU_NUM] = { EMU_SCAN,
						  EMU_1990, EMU_2400, EMU_2401, EMU_2411,
						  EMU_18B20,
						  EMU_2431
						};

byte IDemu_DS[8] = {EMU_DEF, 'S','l','a','w','e','k',0};	// Numer ID naszego emulatora


//todo: na razie tryb skaner & emul niemoliwy wic przez define "IDemu" i "IDtrap" wskazuje na te same dane
#define	IDtrap_DS	IDemu_DS
#define	IDtrap_EE	IDemu_EE
void InitEmul();


#define	MUL_TEMP_0625	0.0625
#define	DEF_TEMP	0x550
word volatile TempDS18b20 = DEF_TEMP;	// TempDS18b20 = temp / 0,0625 (warto startowa 85stopni (0x0550)
byte volatile PwrDS18b20 = 1;			// 1 - zasilana zewnetrzne, 0 - pasoytnicze
byte AlarmIRQ;

#define	EM_UDR_R1		CR
#define	EM_UDR_R2		LF
#define	EM_UDR_SEARCH	's'
#define	EM_UDR_SEARCHOK	'S'
#define	EM_UDR_SKIP		'>'
#define	EM_UDR_MATCH	'm'
#define	EM_UDR_MATCHOK	'M'
#define	EM_UDR_RD		'r'


/*
 register byte stanE asm("r2");					// todo: register w IRQ jest niebezpieczne
 register byte bit_indexE asm("r3");
 register byte search_indexE asm("r4");
 register byte byte_indexE asm("r5");
 register byte byte_rdE asm("r6");
 register byte ZaadesowanyE asm("r7");
*/
byte stanE;
byte bit_indexE, byte_indexE, search_indexE;
byte byte_rdE, subcmdE;

#ifndef OVERDRIVE_OFF
// Jak INIT_ZMIENNE ale nie ruszamy "FL_OVD_" i nie wyczamy IRQ od timera B
 #define	INIT_ZMIENNEovd		bit_indexE = byte_indexE = search_indexE = 0; stanE = OW_ACK
//
// Przejci do trybu overdrive (ustawienie zmiennej i odblokowanie IRQ
 #define	SET_OVERDRIVE		FL_OVD_true; FL_SEND_ZERO_false;\
								STOP_TIMER_OW; \
								TIFR_OW |= ; TIMSK_OW |= _BV(OCIEB_OW)
 #define	INIT_ZMIENNE		bit_indexE = byte_indexE = search_indexE = 0; stanE = OW_ACK;\
								FL_OVD_false; FL_SEND_ZERO_false; \
								TIMSK_OW &= ~_BV(OCIEB_OW)
#else
 #define	INIT_ZMIENNE		bit_indexE = byte_indexE = search_indexE = 0; stanE = OW_ACK;\
								TIMSK_OW &= ~_BV(OCIEB_OW)
#endif

//							//TempL,		 TempH,   		  TH,  TL,  CFG,  xx,   xx,   0x10, CRC
byte scratchpad_18b20[9]  = { low(DEF_TEMP), high(DEF_TEMP),  80,  -15, 0x7F, 0xFF, 0xAA, 0x10, 0 };
byte eeprom_18b20[3] = 										{ 100, -10, 0x7F };
byte scratchpad_2431[8];
//
#define	LEN_2431	144
byte eeprom_2431[LEN_2431];
//
long adrCallEmu;


#ifndef OW_NO_INLINE
 void inline Emuluj_1W();
 void inline RolByte();
 void inline Delay1W_us(double __us);
 void inline Delay1W_ms(double __ms);
 void inline Delay1W_loop_1(uint8_t __count);
 void inline Delay1W_loop_2(uint16_t __count);
#else
 void Emuluj_1W();
 void RolByte();
 #define	Delay1W_us	_dely_us
 #define	Delay1W_ms	_dely_ms
#endif

void EmulujPresence();


byte InterfaceSlaveTest();
void OnewireSlaveInit();
void InitEmulowanyDS();
void InitEmul();
void inline Send_ZERO();
byte *ptrWriteE;


//----- Ponsze nie mog by inline (skok przez wektor adresu -----//
void SubCommand_DS18B20();
void SubCommand_DS2431();
void SubCommand_DS2502();
void SubCommand_UNKOWN();


void InitTimer0();
void InitTimer1();
void DISirqTimer0();
void ENirqTimer0();
#define	DEFRSTMEASURMENT	8
byte RstTigMeasurement = DEFRSTMEASURMENT;
word TimRstTrigger = microSecondsOW( TIM_1W_RST );
byte BusError=FALSE;
void InitInt0();	// 1-Wire enulator


byte volatile eepromTimeOut;


CODE char _header[] = "Header:";
CODE char _name1[] = "Emulator DS18V20";
CODE char _name2[] = "v1.0 (C)2017 AVT";
CODE char _auth[] = "Slawomir Skrzynski (slawomir.skrzynski@ep.com.pl)";
CODE char _date[] = "Compiled: "__DATE__" "__TIME__;
CODE char _lib[] = "AVR-Lib: "__AVR_LIBC_VERSION_STRING__" "__AVR_LIBC_DATE_STRING__;


//=======================================================================//
//=						Fuses											=//
//=======================================================================//
__fuse_t __fuse __attribute__((section (".fuse"))) =
{
#if defined(_AVR_IOTN25_H_) || defined(_AVR_IOTN45_H_) || defined(_AVR_IOTN85_H_)
	.extended	= 0xFF,
	.high		= 0xDD,
	.low		= 0xF1,
#else
  #error "Nieznany typ CPU"
#endif
};


//=======================================================================//
void main()
{
#ifdef SALEAE
  DDRB |= _BV(PB3);
#endif
	wdt_enable( WDTO_500MS );


	#if F_CPU ==  16000000
	  #warning "W fuses zezwol na prace PLL"
	  PLLCSR = _BV(PLLE) | _BV(PLOCK);	// fast mode, timer1 F_CPU (16MHz)
	#endif


	OnewireSlaveInit();		//----- Init portw 1-Wire -----//
	InitEmulowanyDS();
	InitInt0();			// 1-Wire enulator


	InitTimer0();
	InitTimer1();


	ADMUX = 2; // wejcie ADC2 (PB4), Ref Vcc
	ADCSRA = _BV(ADEN) | _BV(ADSC) | _BV(ADATE) | 7;// EN=1, Start, Autorun, preskaler na 128
	// ADCSRA nie ruszamy, FreeRunMode


	sei();
	while( true )
	{
	wdg();


	//----- Usypiamy do czasu wywoania IRQ -----//
	wdt_disable();
	set_sleep_mode( SLEEP_MODE_IDLE );
	sleep_mode();
	wdt_enable( WDTO_500MS );


	//----- Czy alarm temperatury ? -----//
	if ( IDemu_DS[0]==EMU_18B20 )
		{
		if ( PORTB & PB1 ) PwrDS18b20 = 1; else PwrDS18b20 = 0;
		int adc;
		if ( ADCSRA & _BV(ADIF) )				// Jeli jest wynik przetwarzania
			{
			ADCSRA |= _BV(ADIF);				// Kasuj
			adc = ADC << 2;						// Konwersja 10 na 12-bit
			TempDS18b20 = adc - 0x800;						// Konwersja z unsigned na signed
//			if ( !(adc & 0x200) )	TempDS18b20 = adc;
//			else TempDS18b20 = (adc ^ 0xFFFF) + 1;
			}


		char t;
		t = TempDS18b20 >> 4;
		if ( t > (char)scratchpad_18b20[2] )	// TH
			{
			AlarmIRQ = 1;
			}
		else if ( t < (char)scratchpad_18b20[3] )// TL
			{
			AlarmIRQ = -1;
			}
		else
			{
			AlarmIRQ = 0;
			}
		}
	}
}


//=======================================================================//
void OnewireSlaveInit()
{
	#if WIRE1_IN != WIRE1_QD
	  WIRE1_DDR  |= (1<<WIRE1_QD);
	#endif

	#ifdef OVD_WR_HARD
	  FL_SEND_ZERO_DDR;
	#endif

	WIRE1_SET;
}


//----------------------------------------------------------------------//
void InitEmulowanyDS()
{
	//----- Rejestrowanie adresu funkcji emulacji
	switch( IDemu_DS[0] )
	  	{
		case( EMU_18B20 ):	adrCallEmu = &SubCommand_DS18B20;	break;
		case( EMU_2502 ):	adrCallEmu = &SubCommand_DS2502;	break;
		default: adrCallEmu = &SubCommand_UNKOWN;
		}
	InitEmul();
}


//----------------------------------------------------------------------//
// Ponisza funkcja jest wykonywana po odczycie subrozkazu
// i podczas odbioru danych od mastera
//----------------------------------------------------------------------//
void SubCommand_DS2502()
{
TRAP;
}


//----------------------------------------------------------------------//
// Ponisza funkcja jest wykonywana po odczycie subrozkazu
// i podczas odbioru danych od mastera
//----------------------------------------------------------------------//
void SubCommand_DS18B20()
{
word temp;


	if ( stanE == OW_HOST2SLAVE )
		{
		if ( byte_indexE < 3 )	// zapis scratchpad 3 bajtami
			{
			scratchpad_18b20[ 2 + byte_indexE++ ] = byte_rdE;	// +2 bo scratchpad mona zapisa od pozycji 2 (TH)
			}
		return;
		}


	switch( subcmdE )
		{
		//----- Operacje wewnetrzne -----//
		case( ONEWIRE_18b20_CONVERTTEMP ):
			temp = TempDS18b20;
			switch( scratchpad_18b20[4] & 0b01100000 )
				{
				case( DS18B20_RESOLUTION_9 ):	temp &= ~7; break;
				case( DS18B20_RESOLUTION_10 ):	temp &= ~3; break;
				case( DS18B20_RESOLUTION_11 ):	temp &= ~1; break;
				//case( DS18B20_RESOLUTION_12 ):	break;
				}
			scratchpad_18b20[0] = temp;
			scratchpad_18b20[1] = temp >> 8;
			eepromTimeOut = 100 * 1000;	// 100ms
			stanE = OW_IDLE;
			break;
		case( ONEWIRE_18b20_copySCRATCHPAD ):
			eeprom_18b20[0] = scratchpad_18b20[2];
			eeprom_18b20[1] = scratchpad_18b20[3];
			eeprom_18b20[2] = scratchpad_18b20[4];
			eepromTimeOut = 10 * 1000;	// 10ms
			stanE = OW_IDLE;
			break;
		case( ONEWIRE_18b20_recallEEPROM ):
			scratchpad_18b20[2] = eeprom_18b20[0];
			scratchpad_18b20[3] = eeprom_18b20[1];
			scratchpad_18b20[4] = eeprom_18b20[2];
			stanE = OW_IDLE;
			break;
		//----- Operacje odsyania danych (odczytu przez mastera) -----//
		case( ONEWIRE_18b20_RPWRSUPPLY ):
			ptrWriteE = &PwrDS18b20; 		// wskanik na dane do odczytu
			stanE = OW_SLAVE2HOST;
			break;
		case( ONEWIRE_18b20_readSCRATCHPAD ):
			scratchpad_18b20[4] &= 0x7f;	// Bit 7 zawsze 0
			scratchpad_18b20[4] |= 0x1f;	// bity 0..4 zawsze 1
			// Uaktualnie CRC
			scratchpad_18b20[8] = 0; for(uint8_t i=0; i<8; i++) scratchpad_18b20[8] = _crc_ibutton_update(scratchpad_18b20[8], scratchpad_18b20[i] );
			ptrWriteE = scratchpad_18b20; 	// wskanik na dane do odczytu
			stanE = OW_SLAVE2HOST;
			break;
		//----- Operacje pobierania danych (odczytu przez slave) -----//
		case( ONEWIRE_18b20_writeSCRATCHPAD ):
			byte_indexE = 0;
			stanE = OW_HOST2SLAVE;
			break;
//		default: stanE = OW_IDLE;
		}
}


//----------------------------------------------------------------------//
void SubCommand_UNKOWN()
{
	nop();
}


//======================================================================//
//     Init timera dla irq                                       		//
//----------------------------------------------------------------------//
void InitTimer0()
{
	//--- Init timera w trybie 0 ---
//	TCCR0 = 0x7;      				// Preskaler na 1024
//	TIMSK |= ( 1<<TOIE0 );    		// Zezwolenie na IRQ od przepenienia timera

	//--- Init timera w trybie CTC ---
	TCCR0A = (1<<WGM01);			// tryb CTC
	TCCR0B |= 0x5;					// Preskaler na 1024
	OCR0A = 1 * F_CPU/1000 / 1024;	// 1ms * F_CPU/1000 / PRESKALER

	ENirqTimer0();		 		   	// Zezwolenie na IRQ od porwnania timera
}


//----------------------------------------------------------------------//
//					Wycza IRQ od timera
//----------------------------------------------------------------------//
void DISirqTimer0()
{
	TIMSK &= ~( 1<<OCIE0A ); 	   	// Zezwolenie na IRQ od porwnania timera
}


//----------------------------------------------------------------------//
//					Wcza IRQ od timera
//----------------------------------------------------------------------//
void ENirqTimer0()
{
	TIFR |= _BV(OCF0A);				// Kasuje flag IRQ
	TIMSK |= ( 1<<OCIE0A ); 		   	// Zezwolenie na IRQ od porwnania timera
}


//----------------------------------------------------------------------//
//     Obsuga IRQ od timera 0 (tryb CTC)                               //
//																		//
// Przerwanie co:					1ms (1000us)						//
//----------------------------------------------------------------------//
INTERRUPT(TIMER0_COMPA_vect)
{
	if ( eepromTimeOut )	eepromTimeOut--;
}




//======================================================================//
//			Nicjalizacja IRQ od wejcia INT 5 (1-Wire emulator)			//
//----------------------------------------------------------------------//
void InitInt0()
{
	MCUCR |= (2<<ISC00);	//Konfiguracja przerwania INT0: zbocze opadajce
	GIMSK |= (1<<INT0);		//Odblokowanie przerwania INT0
}


//----------------------------------------------------------------------//
//			Obsuga IRQ od wejcia INT 5 (1-Wire emulator)				//
//----------------------------------------------------------------------//
SIGNAL( INT0_vect )			// Musi by SIGNAL a nie INTERRUPT  jeli wyzwalanie poziomem
{
//Przy 16MHz wejcie w IRQ 2,6us
#ifdef SALEAE
  PORTB &= ~_BV(PB3);
#endif
	START_TIMER_OW;			// Uruchamiamy Timer odmierzajcy czas impulsu 0, uywane do wykrycia resetu przez CompA i B
	irq_Emuluj_1W();
	GIFR |= _BV(INTF0);		// Kasujemy IRQ, ktre mogo powsta podczas generowania ACK
}


//======================================================================//
//						Emulacja w IRQ									//
//----------------------------------------------------------------------//
// !!!!WANE dla trybu overdrive:										//
// Nie wychodzi z funkcji przez return,								//
// Zamiast tego skok na koniec funkcji przez goto,						//
// w przeciwnym wypadku funkcja w overdrive	zoe zablokowa mogistral.	//
//----------------------------------------------------------------------//
void inline irq_Emuluj_1W()
{
	switch( stanE )
		{
		case( OW_IDLE ):
				return;				// Wychodzimy, bo obsugiwany przez timer
/*
			while( !WIRE1_RD );		// Czekamy, a Master zwolni magistral 1-wire
			// Timer ju liczy bo wystartowany jest w przerwaniu
			if ( TCNT_OW > microSecondsOW(TIM_1W_RST) )
			STOP_TIMER_OW;
				{
				CLR_ZMIENNE;
				//Odebrano oczekiwany sygna RESET
				//Wystawiamy sygna PRESENCE by zasygnalizowa obecno
				//ukadu Slave na magistrali 1-wire
				WIRE1_RESET;
				_delay_us(TIM_PRESENCE);
				WIRE1_SET;
				while( !WIRE1_RD );	// Czekamy, a inne Slave zwolni magistral 1-wire
				stanE = OW_WAIT_FOR_COMMAND;
				}
			break;
*/

		case( OW_ACK ):				// Koniec impulsu reset
				return;				// Wychodzimy, bo obsugiwany przez timer
/*				#ifndef OVERDRIVE_OFF
				  // TIM_PRESENCE (standardowa prdko) generowany jest przez IRQ od CompA i CompC
				  //if ( !FL_OVD_RD ) _delay_us( TIM_PRESENCE ); else _delay_us( TIM_PRESENCE_ovd );
				  if ( FL_OVD_RD )
				  	{
					WIRE1_RESET;
				 	_delay_us( TIM_PRESENCE_ovd );
					WIRE1_SET;
					while( !WIRE1_RD );	// Czekamy, a inne Slave zwolni magistral 1-wire
					//LedPresenseOff();
					stanE = OW_WAIT_FOR_COMMAND;
					}
				#else
//
//				  // TIM_PRESENCE (standardowa prdko) generowany jest przez IRQ od CompA i CompC
//					WIRE1_SET;
//					_delay_us( TIM_PRESENCE );
//					while( !WIRE1_RD );	// Czekamy, a inne Slave zwolni magistral 1-wire
//					stanE = OW_WAIT_FOR_COMMAND;
				#endif
*/
			break;
		case( OW_WAIT_FOR_COMMAND ):
			irq_RolByte();
			if(++bit_indexE == 8)  						//Odebrano peen rozkaz
				{
				switch( byte_rdE )
					{
					case( ONEWIRE_CMD_SEARCHROM ):
nop();
						stanE = OW_SEARCH_ROM;  		//Zmiana stanu procedury obsugi magistrali 1-wire
						break;
					case( ONEWIRE_CMD_ALARMSEARCH ):	// Realizowa jeli ukad obsuguje ten rozkaz
						#ifdef FAST1W
							stanE = OW_SEARCH_ROM;  	//Zmiana stanu
						#else
						  if ( (IDemu_DS[0]==EMU_18B20) )
							{
							if ( AlarmIRQ ) stanE = OW_SEARCH_ROM;
							else stanE = OW_IDLE;
							}
						  else stanE = OW_IDLE;
						#endif
						break;
					case( ONEWIRE_CMD_READROM ):
						stanE = OW_READ_ROM;  			//Zmiana stanu
						break;
					case( ONEWIRE_CMD_SKIPROM ):
						stanE = OW_WAIT_SUBCOMMAND;		//Zmiana stanu
						break;
					#ifndef OVERDRIVE_OFF
					  case( ONEWIRE_OVD_SKIPROM ):		// Realizowa jeli ukad obsuguje ten rozkaz
						#ifdef FAST1W
							SET_OVERDRIVE;
							stanE = OW_WAIT_SUBCOMMAND;	//Zmiana stanu
						#else
						  if ( EmulowanyRD==EMU_2431 )
							{
							SET_OVERDRIVE;
							stanE = OW_WAIT_SUBCOMMAND;	//Zmiana stanu
							}
						  else stanE = OW_IDLE;
						#endif
						break;
					#endif
					case( ONEWIRE_CMD_MATCHROM ):
						stanE = OW_MATCHROM;
						break;
					#ifndef OVERDRIVE_OFF
					  case( ONEWIRE_OVD_MATCHROM ):		// Realizowa jeli ukad obsuguje ten rozkaz
						  #ifdef FAST1W
							SET_OVERDRIVE;
							stanE = OW_MATCHROM;  		//Zmiana stanu
						  #else
						   if ( (EmulowanyRD==EMU_2431) )
							{
							SET_OVERDRIVE;
							stanE = OW_MATCHROM;  		//Zmiana stanu
							}
						  else stanE = OW_IDLE;
						#endif
						break;
					#endif
					#ifndef OVERDRIVE_OFF
					  case( ONEWIRE_OVD_RESUME ):		// Realizowa jeli ukad obsuguje ten rozkaz
						LedOverdriveOn();
						LedAdrOn();
						#ifdef FAST1W
							LedAdrOn();
							stanE = OW_WAIT_SUBCOMMAND;	//Zmiana stanu
						#else
						  if ( (EmulowanyRD==EMU_2431) )
							{
							LedAdrOn();
							stanE = OW_WAIT_SUBCOMMAND;	//Zmiana stanu
							}
						  else stanE = OW_IDLE;
						#endif
						break;
					#endif
					default: stanE = OW_IDLE;
					}
				bit_indexE = 0;				  			//Zerowanie zmiennych pomocniczych
				}
			break; 	// ***end*** OW_WAIT_FOR_COMMAND
		case( OW_READ_ROM ):
			//Jeli aktualnie transmitowany bit=0 -> cigamy magistral 1-wire przez kolejne 45us
			//Jeli ten bit=1 -> nie robimy nic, magistrala zostanie podcignita do VCC
			if( (IDemu_DS[byte_indexE] & (1<<bit_indexE) ) == 0) Send_ZERO();
			if(++bit_indexE == 8)  //Przesano wanie 8 bitw biecego bajta
				{
				bit_indexE = 0;
				//Przesano wanie wszystkie bajty numeru ID - zatrzymujemy zegar odmierzajcy timeout
				if(++byte_indexE == 8) stanE = OW_IDLE;
				}
			break;
		case( OW_MATCHROM ):
			irq_RolByte();
			if(++bit_indexE == 8)  						//Odebrano peen rozkaz
				{
				bit_indexE = 0;
				if ( byte_rdE != IDemu_DS[byte_indexE] )
					{
					stanE = OW_IDLE;
					}
				if ( ++byte_indexE == 8 )
					{
					byte_indexE = 0;
					stanE = OW_WAIT_SUBCOMMAND;
					}
				}
			break;
		case( OW_WAIT_SUBCOMMAND ):	// Odbir subkomendy po rozkazie SKIP, MATCH lub RESUME
			irq_RolByte();
			if(++bit_indexE == 8)  						// Odebrano cay subrozkaz
				{
				bit_indexE = 0;
				subcmdE = byte_rdE;						// Zapamitanie subkomendy
/*todo:
// moe dziaa w overdrive wic:
// eepromTimeOut musiaby ustawia FL_SEND_ZERO_OVD
// w irq eepromTimeOut kasowa powysz plag
				if ( eepromTimeOut )					// Jeli ukad zajty (zapis eeprom, konwersja temperatury)
					{
					Send_ZERO();					// Odpowiedz zerem
					goto irq_Emuluj_1W_EXIT;
					}
*/
				// Realizacja rna zalenie od emulowanego ukadu
				(*((void(*)(void))adrCallEmu))();		// CALL do funkcji o adresie "adrCallEmu" czyli:
				// Subcommand_DS2431
				// Subcommand_DS18B20
				// Subcommand_DS2502 itp, itd
				}
			break;
		case( OW_HOST2SLAVE ):							// Odbieranie danych z hosta
			irq_RolByte();
			if(++bit_indexE == 8)  						// Odebrano cay bajt
				{
				bit_indexE = 0;
				// Realizacja rna zalenie od emulowanego ukadu
				(*((void(*)(void))adrCallEmu))();		// CALL do funkcji o adresie "adrCallEmu"
				// Subcommand_DS2431
				// Subcommand_DS18B20
				// Subcommand_DS2502 itp, itd
				}
			break;
		case( OW_SLAVE2HOST ):							// Wysyanie danych do hosta
			    if( !(*ptrWriteE & (1<<bit_indexE) ) )
					{
			    	Send_ZERO(); 	// Wystawienie bitu w trybie normalnym (15,5kb/s)
					}
			if(++bit_indexE == 8)  						// Wysano cay bajt
				{
				bit_indexE = 0;
				ptrWriteE++;							// Wslkanik na next bajt, nie sprawdzamy zakresu bo to odczyt
				}
			break;
		case( OW_SEARCH_ROM ):
			//W trakcie procedury SEARCH_ROM wykonywane s 3 operacje (okrelone wartoci zmiennej searchIndex) dla kadego
			//bitu adresu ID: wysanie bitu, wysanie zanegowanego bitu oraz odczyt bitu przesanego przez ukad Master i nastepujce
			//po tym porwnanie odczytanego bitu z bitem adresu ID urzdzenia Slave
			switch( search_indexE )
				{
				case 0: //Wysanie bitu z biecej pozycji numeru ID
					if( (IDemu_DS[byte_indexE] & (1<<bit_indexE) ) == 0) Send_ZERO();
					break;
				case 1: //Wysanie zanegowanego bitu z biecej pozycji numeru ID
					if( (IDemu_DS[byte_indexE] & (1<<bit_indexE) ) != 0) Send_ZERO();
					break;
				case 2: //Odczyt bitu przesanego przez ukad Master
						//Ukad Master przesya w odpowiedzi biecy bit a Slave porwnuje go ze swoim bitem w tym miejscu
                   		//numeru ID i jeli si zgadza to proces poda dalej a jeli nie to Slave przechodzi do bezczynnoci
					delayREAD_BIT_1W();
					//if ( (((IDemu_DS[byte_indexE] & (1<<bit_indexE)) == 0) && WIRE1_RD != 0) ||
					//     (((IDemu_DS[byte_indexE] & (1<<bit_indexE)) != 0) && WIRE1_RD == 0) ) stanE = OW_IDLE;
					// w/w pop poprawce (wane w overdrive)
					byte bit;
					bit = WIRE1_RD;
					if ( (((IDemu_DS[byte_indexE] & (1<<bit_indexE)) == 0) && bit != 0) ||
					     (((IDemu_DS[byte_indexE] & (1<<bit_indexE)) != 0) && bit == 0) ) stanE = OW_IDLE;
					break;
				}
			if(++search_indexE == 3)  //Komplet operacji dla biecego bitu
				{
				search_indexE = 0;
				if(++bit_indexE == 8)  //Przetworzono ju 8 bitw biecego bajta
					{
					bit_indexE = 0;
					//Prztworzono wanie wszystkie bajty numeru ID - zatrzymujemy zegar odmierzajcy timeout
					if(++byte_indexE == 8) stanE = OW_IDLE;
					}
				}
			break;	// ***end*** OW_SEARCH_ROM
		}


//irq_Emuluj_1W_EXIT:			// zamiast return;
}


//----------------------------------------------------------------------//
void inline irq_RolByte()
{
//Przy 16MHz wejcie to 4,25us

#ifdef SALEAE
  PORTB |= _BV(PB3);
#endif
	delayREAD_BIT_1W();
//	if( WIRE1_RD ) byte_rdE |= (1<<bit_indexE);		// OK (teraz le) - wymaga zerowania "byte_rdE" przed odczytem
//	if( WIRE1_RD ) byte_rdE |= (1<<bit_indexE); else byte_rdE &= ~(1<<bit_indexE);	// OK - nie wymaga zerowania "byte_rdE"
	byte_rdE >>= 1; if( WIRE1_RD ) byte_rdE |= 0x80; // OK - nie wymaga zerowania "byte_rdE"
#ifdef SALEAE
  PORTB &= ~_BV(PB3);
#endif
}


//----------------------------------------------------------------------//
void inline Send_ZERO()
{
	WIRE1_RESET;


	//----- ZERO w irq -----//
	OCRB_OW = microSecondsOW( TIM_BIT_ZERO );	// Przerwanie po 240us (wczane po RST)
	START_TIMER_OW;				// Uruchamiamy odliczanie
	TIFR_OW |= _BV(OCFB_OW);	// Kasuj flag przerwania
	TIMSK_OW |= _BV(OCIEB_OW);	// Odblokowanie przerwa od porwnania z Comp B (160us)

/*
#warning "zero przez delay"
	//----- ZERO przez delay -----//
	_delay_us( TIM_BIT_ZERO );//Delay1W_us( TIM_BIT_ZERO );
	WIRE1_SET;
*/
}


//=======================================================================//
void InitTimer1()
{
	TIMSK_OW |= _BV(TOIE_OW);					// Wczenie irq od przepenienia
	OCRA_OW = microSecondsOW( TIM_1W_RST );		// Przerwanie po 460us
	TIMSK_OW |= _BV(OCIEA_OW);					// Odblokowanie przerwa od porwnania z Comp A
	OCRB_OW = microSecondsOW( TIM_PRESENCE );	// Przerwanie po 240us (wczane po RST)
nop();
}


//----------------------------------------------------------------------//
//					Przerwanie od sygnau RESET							//
//----------------------------------------------------------------------//
SIGNAL( TIMER1_COMPA_vect )
{
long static srednia=0;
word tim;
byte fl=0;


	WIRE1_SET;
	if ( !WIRE1_RD ) 			// Jeli timer przepeniono a magistrala jest w stanie niskim
		{						// to mamy reset (przepenienie jest na 440us a nie 480)
		#ifndef ALARM_OFF
		  #ifdef ALARM_ALWYES_ON
		    #warning "USER: Alarm/IRQ slave generowany zawsze"
			if ( AlarmIRQ )
		  #endif
			{
			WIRE1_RESET;
			#warning "USER: mozna zaangarzowac irq"
			//todo:
			//timerkw mao, wic naley uy CompA, zmieni mu ustawienie czasu ustawi znacznik e presece
			// w IRQ przywrci znacznik presence, 1W w stan H i wpisa czas resetu
			_delay_ms( 2 );
			WIRE1_SET;
			}
		#endif
		while( !WIRE1_RD )			// Czekamy, a master zwolni magistral 1-wire
			{						// Jeli zbyt dugo to wyjd
			#if defined(_AVR_IOTN25_H_) || defined(_AVR_IOTN45_H_) || defined(_AVR_IOTN85_H_)
			  if ( TIFR & _BV(TOV1) )	// Jeli przepenienie
				{
				TIFR |= _BV(TOV1);		// kasuj
				fl++;					// licz przerwania
				if ( fl > 4 ) return;	// Przekrozono 4ms
				}
			#endif
/*
			tim = TCNT_OW;
			if ( tim > microSecondsOW( TIM_1W_RSTfail ) )
				{
#if F_CLP > 16000000
//todo: jak pujdzie na 14,7MHz to rozrni irq od fail
//jak nie to na 22MHz uyc irq od przepenienia, tam liczy dodatkowy bajt (bit) czasu
 #warning "USER: Problem z rozroznieniem IRQ od bledu magistrali"
#endif
				return;
				}
*/
			}
		EmulujPresence();
		// Wyliczanie redniej czasu sygnau reset
		}
//	else						// Timer przepeniony a magistrala w wysokim, zatrzymaj wic go
//		{
//		STOP_TIMER_OW;
//		}
}


//----------------------------------------------------------------------//
//					Przerwanie koczce PRESENCE						//
//----------------------------------------------------------------------//
SIGNAL( TIMER1_COMPB_vect )		// Min czas generowania sygnau presence lub zera
{
	WIRE1_SET;
#ifdef SALEAE
  PORTB |= _BV(PB3);
#endif
	TIMSK_OW &= ~_BV(OCIEB_OW);	// Wyczenie IRQ od porwnania z Comp C
//	STOP_TIMER_OW;

	if ( OCRB_OW == microSecondsOW( TIM_PRESENCE ) )
		{
		stanE = OW_WAIT_FOR_COMMAND;
		}
}


//----------------------------------------------------------------------//
//				Przerwanie awaryjne (np uszkodzona magistrala)			//
//----------------------------------------------------------------------//
INTERRUPT(TIMER1_OVF_vect)
{
	if ( !WIRE1_RD ) 			// Jeli timer przepeniono a magistrala jest w stanie niskim
		{
		WIRE1_SET;
		BusError = true;
/*
		INIT_ZMIENNE;
		RstTigMeasurement = DEFRSTMEASURMENT;
		OCRA_OW = TimRstTrigger = microSecondsOW( TIM_1W_RST );
*/
		}
//	else
//		{
//		STOP_TIMER_OW;
//		}
}


//----------------------------------------------------------------------//
void EmulujPresence()
{
	INIT_ZMIENNE; 				// Wyczenie overdrive
	_delay_us( TIM_1W_RSTtpdh );

	WIRE1_RESET;				// Pocztek sygnau ACK
	START_TIMER_OW;				// Uruchamiamy odliczanie
	OCRB_OW = microSecondsOW( TIM_PRESENCE );	// Przerwanie po 160us (wczane po RST)
	TIFR_OW |= _BV(OCFB_OW);	// Kasuj flag przerwania
	TIMSK_OW |= _BV(OCIEB_OW);	// Odblokowanie przerwa od porwnania z Comp C (160us)
}


//----------------------------------------------------------------------//
void InitEmul()
{
	//Aktualizacja sumy CRC8 z pierwszych 7 bajtw tablicy numeru ID naszego ukadu Slave
	IDemu_DS[7] = 0; for(uint8_t i=0; i<7; i++) IDemu_DS[7] = _crc_ibutton_update(IDemu_DS[7], IDemu_DS[i]);
}


//----------------------------------------------------------------------//
